Index: issm/trunk/src/c/classes/objects/Profiler.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Profiler.cpp	(revision 13975)
+++ issm/trunk/src/c/classes/objects/Profiler.cpp	(revision 13975)
@@ -0,0 +1,174 @@
+/*!\file Profiler.c
+ * \brief: implementation of the Profiler object
+ */
+
+/*Include files: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include "./Profiler.h"
+/*}}}*/
+
+/*Profiler constructors and destructors:*/
+/*FUNCTION Profiler::Profiler() default constructor {{{*/
+Profiler::Profiler(){
+		 this->time=new Parameters();
+		 this->flops=new Parameters();
+		 this->memory=new Parameters();
+}
+/*}}}*/
+/*FUNCTION Profiler::~Profiler(){{{*/
+Profiler::~Profiler(){
+	delete time;
+	delete flops;
+	delete memory;
+}
+/*}}}*/
+
+/*Object virtual functions definitions:*/
+/*FUNCTION Profiler::Echo{{{*/
+void Profiler::Echo(void){
+
+	_printLine_("Profiler:");
+	_printLine_("   time tags: ");
+	this->time->Echo();
+
+}
+/*}}}*/
+/*FUNCTION Profiler::DeepEcho{{{*/
+void Profiler::DeepEcho(void){
+
+	_printLine_("Profiler:");
+	_printLine_("   time tags: ");
+	this->time->DeepEcho();
+
+}
+/*}}}*/
+/*FUNCTION Profiler::Id{{{*/
+int    Profiler::Id(void){ return -1; }
+/*}}}*/
+/*FUNCTION Profiler::ObjectEnum{{{*/
+int Profiler::ObjectEnum(void){
+
+	return ProfilerEnum;
+
+}
+/*}}}*/
+
+/*Profiler routines:*/
+/*FUNCTION Profiler::Tag {{{*/
+void  Profiler::Tag(int tagenum,bool dontmpisync){
+
+	IssmDouble t;
+	IssmDouble f;
+	IssmDouble m;
+
+	/*If mpisync requested, make sure all the cpus are at the same point 
+	 *in the execution: */
+	if(!dontmpisync){
+		#ifdef _HAVE_MPI_
+		MPI_Barrier(IssmComm::GetComm()); 
+		#endif
+	}
+
+	/*Capture time: */
+	#ifdef _HAVE_MPI_
+	t=MPI_Wtime();
+	#else
+	t=(IssmPDouble)clock();
+	#endif
+
+	/*Capture flops: */
+	#ifdef _HAVE_PETSC_
+		PetscGetFlops(&f);
+		PetscMemoryGetCurrentUsage(&m);
+	#else
+		/*do nothing for now:*/
+	#endif
+
+	/*Plug into this->time: */
+	this->time->AddObject(new DoubleParam(tagenum,t));
+	this->flops->AddObject(new DoubleParam(tagenum,f));
+	this->memory->AddObject(new DoubleParam(tagenum,m));
+
+}
+/*}}}*/
+/*FUNCTION Profiler::DeltaTime {{{*/
+IssmDouble  Profiler::DeltaTime(int inittag, int finaltag){
+
+	IssmDouble init, final;
+	this->time->FindParam(&init,inittag);
+	this->time->FindParam(&final,finaltag);
+
+	#ifdef _HAVE_MPI_
+	return final-init;
+	#else
+	return (final-init)/CLOCKS_PER_SEC;
+	#endif
+}
+/*}}}*/
+/*FUNCTION Profiler::DeltaFlops {{{*/
+IssmDouble  Profiler::DeltaFlops(int inittag, int finaltag){
+
+	IssmDouble init, final;
+	this->flops->FindParam(&init,inittag);
+	this->flops->FindParam(&final,finaltag);
+
+	return final-init;
+}
+/*}}}*/
+/*FUNCTION Profiler::DeltaTimeModHour {{{*/
+int Profiler::DeltaTimeModHour(int inittag, int finishtag){
+
+	IssmDouble init, finish;
+	this->time->FindParam(&init,inittag);
+	this->time->FindParam(&finish,finishtag);
+
+	#ifdef _HAVE_MPI_
+	return int((reCast<int,IssmDouble>(finish-init))/3600);
+	#else
+	return int((reCast<int,IssmDouble>(finish-init))/CLOCKS_PER_SEC/3600);
+	#endif
+
+}
+/*}}}*/
+/*FUNCTION Profiler::DeltaTimeModMin {{{*/
+int Profiler::DeltaTimeModMin(int inittag, int finishtag){
+
+	IssmDouble init, finish;
+	this->time->FindParam(&init,inittag);
+	this->time->FindParam(&finish,finishtag);
+
+	#ifdef _HAVE_MPI_
+	return int(int(reCast<int,IssmDouble>(finish-init))%3600/60);
+	#else
+	return int(int(reCast<int,IssmDouble>(finish-init))/CLOCKS_PER_SEC%3600/60);
+	#endif
+}
+/*}}}*/
+/*FUNCTION Profiler::DeltaTimeModSec {{{*/
+int Profiler::DeltaTimeModSec(int inittag, int finishtag){
+
+	IssmDouble init, finish;
+	this->time->FindParam(&init,inittag);
+	this->time->FindParam(&finish,finishtag);
+
+	#ifdef _HAVE_MPI_
+	return int(reCast<int,IssmDouble>(finish-init))%60;
+	#else
+	return int(reCast<int,IssmDouble>(finish-init))/CLOCKS_PER_SEC%60;
+	#endif
+}
+/*}}}*/
+/*FUNCTION Profiler::Memory {{{*/
+IssmDouble  Profiler::Memory(int tag){
+
+	IssmDouble m;
+	this->memory->FindParam(&m,tag);
+
+	return m;
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/objects/Profiler.h
===================================================================
--- issm/trunk/src/c/classes/objects/Profiler.h	(revision 13975)
+++ issm/trunk/src/c/classes/objects/Profiler.h	(revision 13975)
@@ -0,0 +1,57 @@
+/*!\file Profiler.h
+ * \brief: header file for node object
+ */
+
+#ifndef _PROFILER_H_
+#define _PROFILER_H_
+
+/*Headers:*/
+/*{{{*/
+#include "./Object.h"
+#include "../../shared/shared.h"
+/*}}}*/
+
+class DataSet;
+class Parameters;
+
+enum ProfilerEnums {
+	Start,
+	StartInit,
+	FinishInit,
+	StartCore,
+	FinishCore,
+	StartAdCore,
+	FinishAdCore,
+	Finish
+};
+
+class Profiler: public Object{
+
+	public: 
+		Parameters*  time;
+		Parameters*  flops;
+		Parameters*  memory;
+
+		/*Profiler constructors, destructors {{{*/
+		Profiler();
+		~Profiler();
+		/*}}}*/
+		/*Object virtual functions definitions:{{{ */
+		void    Echo();
+		void    DeepEcho();
+		int     Id();
+		int     ObjectEnum();
+		Object *copy()        {_error_("Not implemented yet"); };
+		/*}}}*/
+		/*Profiler routines {{{*/
+		void    Tag(int tagenum,bool dontmpisync=false);
+		IssmDouble  Memory(int tag);
+		IssmDouble  DeltaTime(int inittag, int finaltag);
+		IssmDouble  DeltaFlops(int inittag, int finaltag);
+		int     DeltaTimeModHour(int inittag, int finaltag);
+		int     DeltaTimeModMin(int inittag, int finaltag);
+		int     DeltaTimeModSec(int inittag, int finaltag);
+		/*}}}*/
+};
+
+#endif  /* _PROFILER_H_ */
Index: issm/trunk/src/c/classes/objects/Segment.h
===================================================================
--- issm/trunk/src/c/classes/objects/Segment.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Segment.h	(revision 13975)
@@ -15,5 +15,5 @@
 
 	public:
-		int eid;
+		int        eid;
 		doubletype x1;
 		doubletype y1;
@@ -21,13 +21,12 @@
 		doubletype y2;
 
-
 		/*Segment constructors, destructors :*/
 		/*FUNCTION Segment() default constructor {{{*/
 		Segment(){
-			this->eid=UNDEF;
-			this->x1=UNDEF;
-			this->y1=UNDEF;
-			this->x2=UNDEF;
-			this->y2=UNDEF;
+			this->eid = UNDEF;
+			this->x1  = UNDEF;
+			this->y1  = UNDEF;
+			this->x2  = UNDEF;
+			this->y2  = UNDEF;
 		}
 		/*}}}*/
@@ -35,9 +34,9 @@
 		Segment(int segment_eid, doubletype segment_x1,doubletype segment_y1,doubletype segment_x2, doubletype segment_y2){
 
-			this->eid=segment_eid;
-			this->x1=segment_x1;
-			this->y1=segment_y1;
-			this->x2=segment_x2;
-			this->y2=segment_y2;
+			this->eid = segment_eid;
+			this->x1  = segment_x1;
+			this->y1  = segment_y1;
+			this->x2  = segment_x2;
+			this->y2  = segment_y2;
 
 		}
@@ -67,11 +66,4 @@
 		int    Id(void){ return eid; }
 		/*}}}*/
-		/*FUNCTION MyRank{{{*/
-		int    MyRank(void){ 
-			extern int my_rank;
-
-			return my_rank; 
-		}
-		/*}}}*/
 		/*FUNCTION ObjectEnum{{{*/
 		int ObjectEnum(void){
@@ -84,7 +76,5 @@
 		Object* copy() {
 			return new Segment(this->eid,this->x1,this->y1,this->x2,this->y2);
-
 		}
-
 		/*}}}*/
 
Index: issm/trunk/src/c/classes/objects/Vertex.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Vertex.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Vertex.cpp	(revision 13975)
@@ -49,4 +49,5 @@
 	this->id=vertex_id;
 	this->sid=vertex_sid;
+	this->pid=UNDEF;
 	this->x=vertex_x;
 	this->y=vertex_y;
@@ -54,5 +55,4 @@
 	this->sigma=vertex_sigma;
 	this->connectivity=vertex_connectivity;
-	this->dof=UNDEF;
 
 	return;
@@ -67,4 +67,5 @@
 	_printLine_("   id: " << id);
 	_printLine_("   sid: " << sid);
+	_printLine_("   pid: " << pid);
 	_printLine_("   x: " << x);
 	_printLine_("   y: " << y);
@@ -72,5 +73,4 @@
 	_printLine_("   sigma: " << sigma);
 	_printLine_("   connectivity: " << connectivity);
-	_printLine_("   dof: " << dof);
 	_printLine_("   clone: " << clone);
 
@@ -86,10 +86,4 @@
 int    Vertex::Id(void){ return id; }
 /*}}}*/
-/*FUNCTION Vertex::MyRank {{{*/
-int    Vertex::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Vertex::ObjectEnum{{{*/
 int Vertex::ObjectEnum(void){
@@ -103,88 +97,4 @@
 
 	return new Vertex(*this); 
-
-}
-/*}}}*/
-
-/* DofObject routines: */
-/*FUNCTION Vertex::DistributeDofs{{{*/
-void  Vertex::DistributeDofs(int* pdofcount){
-
-	int i;
-	extern int my_rank;
-	int dofcount;
-
-	dofcount=*pdofcount;
-	
-	if(this->clone){
-		/*This vertex is a clone! Don't distribute dofs, it will get them from another cpu!*/
-		return;
-	}
-
-	/*This vertex should distribute his dof, go ahead: */
-	this->dof=dofcount;
-	dofcount++;
-
-	/*Assign output pointers: */
-	*pdofcount=dofcount;
-
-}
-/*}}}*/
-/*FUNCTION Vertex::OffsetDofs{{{*/
-void  Vertex::OffsetDofs(int dofcount){
-	
-	int i;
-	extern int my_rank;
-	
-	if(this->clone){
-		/*This vertex is a clone, don't offset the dofs!: */
-		return;
-	}
-
-	/*This vertex should offset his dof, go ahead: */
-	this->dof+=dofcount;
-}
-/*}}}*/
-/*FUNCTION Vertex::ShowTrueDofs{{{*/
-void  Vertex::ShowTrueDofs(int* truedofs){
-
-	int j;
-	extern int my_rank;
-	
-	/*Are we a clone? : */
-	if(this->clone)return;
-
-	/*Ok, we are not a clone, just plug our dof into truedofs: */
-	truedofs[this->id-1]=this->dof;
-
-}
-/*}}}*/
-/*FUNCTION Vertex::UpdateCloneDofs{{{*/
-void  Vertex::UpdateCloneDofs(int* alltruedofs){
-
-	int j;
-	extern int my_rank;
-	
-	/*If we are not a clone, don't update, we already have dofs!: */
-	if(this->clone==0)return;
-
-	/*Ok, we are a clone node, but we did not create the dof for this vertex 
-	 * Therefore, our dof is garbage right now. Go pick it up in the alltruedofs: */
-	this->dof=alltruedofs[id-1];
-}
-/*}}}*/
-/*FUNCTION Vertex::SetClone {{{*/
-void  Vertex::SetClone(int* minranks){
-
-	extern int my_rank;
-
-	if (minranks[id-1]==my_rank){
-		this->clone=0;
-	}
-	else{
-		/*!there is a cpu with lower rank that has the same vertex, 
-		therefore, I am a clone*/
-		this->clone=1; 	
-	}
 
 }
@@ -209,10 +119,77 @@
 	/*sigma remains constant. z=bed+sigma*thickness*/
 	oldz = this->z;
-	newz = bed[this->dof]+sigma*thickness[this->dof];
+	newz = bed[this->pid]+sigma*thickness[this->pid];
 	velz = (newz-oldz)/dt;
 	this->z = newz;
 
 	/*put vz in vector*/
-	vz->SetValue(this->dof,velz,INS_VAL);
+	vz->SetValue(this->pid,velz,INS_VAL);
 }
 /*}}}*/
+/*FUNCTION Vertex::DistributePids{{{*/
+void  Vertex::DistributePids(int* ppidcount){
+
+	/*retrieve current pid*/
+	int pidcount=*ppidcount;
+
+	/*This vertex is a clone! Don't distribute pids, it will get them from another cpu!*/
+	if(this->clone) return;
+
+	/*This vertex should distribute its pid*/
+	this->pid=pidcount;
+	pidcount++;
+
+	/*Assign output pointers: */
+	*ppidcount=pidcount;
+}
+/*}}}*/
+/*FUNCTION Vertex::OffsetPids{{{*/
+void  Vertex::OffsetPids(int pidcount){
+
+	/*This vertex is a clone, don't offset the pids*/
+	if(this->clone) return;
+
+	/*This vertex should offset his pid, go ahead: */
+	this->pid+=pidcount;
+}
+/*}}}*/
+/*FUNCTION Vertex::ShowTruePids{{{*/
+void  Vertex::ShowTruePids(int* truepids){
+
+	/*Are we a clone? : */
+	if(this->clone)return;
+
+	/*Ok, we are not a clone, just plug our pid into truepids: */
+	truepids[this->sid]=this->pid;
+}
+/*}}}*/
+/*FUNCTION Vertex::UpdateClonePids{{{*/
+void  Vertex::UpdateClonePids(int* alltruepids){
+
+	/*If we are not a clone, don't update, we already have pids: */
+	if(!this->clone)return;
+
+	/*Ok, we are a clone node, but we did not create the pid for this vertex 
+	 * Therefore, our pid is garbage right now. Go pick it up in the alltruepids: */
+	this->pid=alltruepids[this->sid];
+}
+/*}}}*/
+/*FUNCTION Vertex::SetClone {{{*/
+void  Vertex::SetClone(int* minranks){
+
+	int my_rank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
+	if (minranks[this->sid]==my_rank){
+		this->clone=false;
+	}
+	else{
+		/*!there is a cpu with lower rank that has the same vertex, 
+		therefore, I am a clone*/
+		this->clone=true;
+	}
+
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/objects/Vertex.h
===================================================================
--- issm/trunk/src/c/classes/objects/Vertex.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Vertex.h	(revision 13975)
@@ -9,29 +9,24 @@
 /*{{{*/
 #include "../classes.h"
-class IoModel;
-template <class doubletype> class Vector;
-class Parameters;
 #include "../../shared/Exceptions/exceptions.h"
 #include "../../toolkits/toolkits.h"
 #include "../../include/include.h"
-
+template <class doubletype> class Vector;
+class Parameters;
+class IoModel;
 /*}}}*/
-
 
 class Vertex: public Object{
 
 	public: 
-
-		int    id;
-		int    sid;            //sid for "serial" id, ie the rank of this vertex in the vertices dataset, if the dataset was serial on 1 cpu.
+		bool       clone;
+		int        id;           // random index
+		int        sid;          // "serial" id (rank of this vertex if the dataset was on 1 cpu)
+		int        pid;          // "parallel" id
 		IssmDouble x;
 		IssmDouble y;
 		IssmDouble z;
-		IssmDouble sigma;          //sigma coordinate: (z-bed)/thickness
-		int    connectivity;   //number of vertices connected to this vertex
-
-		/*dof management: */
-		int    clone;
-		int    dof; //dof to recover values in a vertex indexed vector
+		IssmDouble sigma;        //sigma coordinate: (z-bed)/thickness
+		int        connectivity; //number of vertices connected to this vertex
 
 		/*Vertex constructors, destructors {{{*/
@@ -46,20 +41,16 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
 		/*}}}*/
-		/*DofObject routines {{{*/
-		void  DistributeDofs(int* pdofcount);
-		void  OffsetDofs(int dofcount);
-		void  ShowTrueDofs(int* borderdofs);
-		void  UpdateCloneDofs(int* allborderdofs);
-		void  SetClone(int* minranks);
-		/*}}}*/
-		/*Vertex management: {{{*/
+		/*Vertex management:*/ 
 		int   Sid(void); 
 		int   Connectivity(void); 
 		void  UpdatePosition(Vector<IssmDouble>* vz,Parameters* parameters,IssmDouble* thickness,IssmDouble* bed);
-		/*}}}*/
+		void  DistributePids(int* ppidcount);
+		void  OffsetPids(int pidcount);
+		void  ShowTruePids(int* borderpids);
+		void  UpdateClonePids(int* allborderpids);
+		void  SetClone(int* minranks);
 };
 #endif  /* _VERTEX_H */
Index: issm/trunk/src/c/classes/objects/objects.h
===================================================================
--- issm/trunk/src/c/classes/objects/objects.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/objects.h	(revision 13975)
@@ -13,4 +13,7 @@
 #include "./Vertex.h"
 #include "./Node.h"
+#include "./Profiler.h"
+#include "./DependentObject.h"
+#include "./IndependentObject.h"
 #include "./Segment.h"
 
@@ -119,4 +122,5 @@
 #include "./Params/StringParam.h"
 #include "./Params/TransientParam.h"
+#include "./Params/DataSetParam.h"
 
 #endif
Index: issm/trunk/src/c/include/globals.h
===================================================================
--- issm/trunk/src/c/include/globals.h	(revision 13405)
+++ issm/trunk/src/c/include/globals.h	(revision 13975)
@@ -6,6 +6,8 @@
 #define GLOBALS_H_
 
-int my_rank=0;
-int num_procs=1;
+#include "./types.h"
+#include "../classes/IssmComm.h"
+
+COMM IssmComm::comm;
 
 #endif
Index: issm/trunk/src/c/include/macros.h
===================================================================
--- issm/trunk/src/c/include/macros.h	(revision 13405)
+++ issm/trunk/src/c/include/macros.h	(revision 13975)
@@ -23,5 +23,5 @@
 #define _printf_(flag,...) do{if(flag) PrintfFunction(__VA_ARGS__);}while(0)
 /*}}}*/
-/* _error2_ {{{*/
+/* _error_ {{{*/
 /*new Error exception macro*/
 #ifdef _INTEL_WIN_
@@ -71,24 +71,25 @@
 #endif
 /*}}}*/
-/* ISSMBOOT/ISSMEND {{{*/
+/* ExceptionTrapBegin/ExceptionTrapEnd {{{*/
 
 /*The following macros hide the error exception handling in a matlab module. Just put 
- * ISSMBOOT(); and ISSMEND(); at the beginning and end of a module, and c++ exceptions 
+ * ExceptionTrapBegin(); and ExceptionTrapEnd(); at the beginning and end of a module, and c++ exceptions 
  * will be trapped. Really nifty!*/
 
-#define ISSMBOOT(); \
+#define ExceptionTrapBegin(); \
 	try{
 
-#define ISSMEND(); }\
+#define ExceptionTrapEnd(); }\
 	catch(ErrorException &exception){\
-		exception.Report(); \
-		return 1;\
+		exception.Report();\
+		return 0;\
 	}\
 	catch (exception& e) {\
 		_printf_(true,"Standard exception: %s\n",e.what());\
-		return 1;\
+		return 0;\
 	}\
 	catch(...){\
 		_printf_(true,"An unexpected error occurred");\
+		return 0;\
 	}
 /*}}}*/
Index: issm/trunk/src/c/include/types.h
===================================================================
--- issm/trunk/src/c/include/types.h	(revision 13405)
+++ issm/trunk/src/c/include/types.h	(revision 13975)
@@ -5,5 +5,4 @@
 #ifndef _TYPES_H_
 #define  _TYPES_H_
-
 
 #ifdef HAVE_CONFIG_H
@@ -27,5 +26,5 @@
 #endif  
 
-#ifdef _HAVE_ADOLC_
+#if defined(_HAVE_ADOLC_) &&  !defined(_WRAPPERS_)
 #include "adolc/adolc.h"
 // for active variables
@@ -40,5 +39,11 @@
 #endif
 
-typedef bool IssmBool;
+/*Define communicator: */
+#ifdef _HAVE_MPI_
+#include <mpi.h>
+typedef MPI_Comm COMM;
+#else
+typedef int COMM;
+#endif
 
 #endif //ifndef _TYPES_H_
Index: issm/trunk/src/c/io/Disk/WriteLockFile.cpp
===================================================================
--- issm/trunk/src/c/io/Disk/WriteLockFile.cpp	(revision 13975)
+++ issm/trunk/src/c/io/Disk/WriteLockFile.cpp	(revision 13975)
@@ -0,0 +1,25 @@
+/*!\file:  WriteLockFile.cpp
+ * \brief
+ */ 
+#include <stdio.h>
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+
+void WriteLockFile(char* filename){
+
+	/*recover my_rank:*/
+	int my_rank=IssmComm::GetRank();
+
+	/* output: */
+	FILE* fid=NULL;
+
+	/* Open lock file and write 1 into it: */
+	if(my_rank==0){
+		fid=fopen(filename,"w");
+		if(fid==NULL) _error_("error message: could not open lock file " << filename);
+
+		/*Close file: */
+		if(fclose(fid)!=0) _error_("could not close lock file " << filename);
+	}
+
+}	
Index: issm/trunk/src/c/io/Disk/diskio.h
===================================================================
--- issm/trunk/src/c/io/Disk/diskio.h	(revision 13405)
+++ issm/trunk/src/c/io/Disk/diskio.h	(revision 13975)
@@ -10,4 +10,5 @@
 FILE* pfopen(char* filename,const char* format);
 void  pfclose(FILE* fid,char* filename);
+void WriteLockFile(char* filename);
 
 #endif	/* _IO_H_ */
Index: issm/trunk/src/c/io/Disk/pfclose.cpp
===================================================================
--- issm/trunk/src/c/io/Disk/pfclose.cpp	(revision 13405)
+++ issm/trunk/src/c/io/Disk/pfclose.cpp	(revision 13975)
@@ -16,5 +16,4 @@
 
 	/*Close file handle: */
-	extern int my_rank;
 	_assert_(fid);
 	if(fclose(fid)!=0)_error_("could not close file " << filename);
Index: issm/trunk/src/c/io/Disk/pfopen.cpp
===================================================================
--- issm/trunk/src/c/io/Disk/pfopen.cpp	(revision 13405)
+++ issm/trunk/src/c/io/Disk/pfopen.cpp	(revision 13975)
@@ -16,6 +16,5 @@
 
 	FILE* fid=NULL;
-	extern int my_rank;
-	
+
 	/*Open handle to data on disk: */
 	fid=fopen(filename,format);
@@ -24,3 +23,2 @@
 	return fid;
 }
-
Index: issm/trunk/src/c/io/PrintfFunction.cpp
===================================================================
--- issm/trunk/src/c/io/PrintfFunction.cpp	(revision 13405)
+++ issm/trunk/src/c/io/PrintfFunction.cpp	(revision 13975)
@@ -15,10 +15,10 @@
 	char *buffer = NULL;
 	int   n,size = 100;
-	int         string_size;
-	extern int  my_rank;
-	extern int  num_procs;
-                                                                                                                                                                                                     
+	int   my_rank;
 	//variable list of arguments
 	va_list args;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
 
 	while(true){
@@ -52,5 +52,9 @@
 }
 int PrintfFunction(const string & message){
-	extern int  my_rank;
+	int  my_rank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	if(my_rank==0){
 		printf("%s\n",message.c_str());
@@ -59,5 +63,9 @@
 }
 int PrintfFunction2(const string & message){
-	extern int  my_rank;
+	int  my_rank;
+
+	/*recover my_rank:*/
+	my_rank=IssmComm::GetRank();
+
 	if(my_rank==0){
 		printf("%s",message.c_str());
Index: issm/trunk/src/c/issm.h
===================================================================
--- issm/trunk/src/c/issm.h	(revision 13405)
+++ issm/trunk/src/c/issm.h	(revision 13975)
@@ -12,4 +12,5 @@
 #endif
 
+#include "./include/globals.h" //only include this header file once!
 #include "./include/include.h"
 #include "./shared/shared.h"
Index: issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp
===================================================================
--- issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/AverageOntoPartitionx/AverageOntoPartitionx.cpp	(revision 13975)
@@ -18,10 +18,7 @@
 #include "../modules.h"
 
-			
 void AverageOntoPartitionx(double** paverage, Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,double* vertex_response){
 
-	int     i,j,k;
 	int     dummy;
-
 	int     npart;
 	double *qmu_part  = NULL;
@@ -49,6 +46,6 @@
 
 	/*loop on each element, and add contribution of the element to the partition (surface weighted average): */
-	for(i=0;i<elements->Size();i++){
-		Element* element=(Element*)elements->GetObjectByOffset(i);
+	for(int i=0;i<elements->Size();i++){
+		Element* element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->AverageOntoPartition(partition_contributions,partition_areas,vertex_response,qmu_part);
 	}
Index: issm/trunk/src/c/modules/Bamgx/Bamgx.cpp
===================================================================
--- issm/trunk/src/c/modules/Bamgx/Bamgx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/Bamgx/Bamgx.cpp	(revision 13975)
@@ -20,6 +20,6 @@
 
 	/*intermediary*/
+	int i;
 	int noerr=1;
-	int i,j,num;
 	double costheta=2;
 	double hminaniso=1e-100; 
Index: issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.cpp
===================================================================
--- issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ComputeBasalStressx/ComputeBasalStressx.cpp	(revision 13975)
@@ -29,5 +29,5 @@
 	/*Compute basal stress for each element: */
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->ComputeBasalStress(sigma);
 	}
@@ -38,4 +38,4 @@
 	/*Assign output pointers: */
 	*psigma=sigma;
-	
+
 }
Index: issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.cpp
===================================================================
--- issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ComputeStrainRatex/ComputeStrainRatex.cpp	(revision 13975)
@@ -29,5 +29,5 @@
 	/*Compute basal stress for each element: */
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->ComputeStrainRate(eps);
 	}
@@ -38,4 +38,4 @@
 	/*Assign output pointers: */
 	*peps=eps;
-	
+
 }
Index: issm/trunk/src/c/modules/ConfigureObjectsx/ConfigureObjectsx.cpp
===================================================================
--- issm/trunk/src/c/modules/ConfigureObjectsx/ConfigureObjectsx.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ConfigureObjectsx/ConfigureObjectsx.cpp	(revision 13975)
@@ -24,8 +24,8 @@
 	/*Get analysis type: */
 	parameters->FindParam(&configuration_type,ConfigurationTypeEnum);
-	
+
 	if(VerboseMProcessor()) _pprintLine_("      Configuring elements...");
 	for (i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
+		element=dynamic_cast<Element*>(elements->GetObjectByOffset(i));
 		element->Configure(elements,loads,nodes,materials,parameters);
 	}
@@ -44,5 +44,5 @@
 		}
 	}
-	
+
 	if(VerboseMProcessor()) _pprintLine_("      Configuring materials...");
 	for (i=0;i<materials->Size();i++){
Index: issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStatex.cpp
===================================================================
--- issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStatex.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ConstraintsStatex/ConstraintsStatex.cpp	(revision 13975)
@@ -13,9 +13,4 @@
 void ConstraintsStatex(int* pconverged, int* pnum_unstable_constraints, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads,Materials* materials,  Parameters* parameters){
 
-	int i;
-
-	extern int num_procs;
-	extern int my_rank;
-	
 	/*output: */
 	int converged=0;
@@ -46,5 +41,5 @@
 		converged=1;
 	}
-		
+
 	/*Assign output pointers: */
 	*pconverged=converged;
Index: issm/trunk/src/c/modules/ConstraintsStatex/RiftConstraintsState.cpp
===================================================================
--- issm/trunk/src/c/modules/ConstraintsStatex/RiftConstraintsState.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ConstraintsStatex/RiftConstraintsState.cpp	(revision 13975)
@@ -15,7 +15,6 @@
 int RiftIsPresent(Loads* loads,int configuration_type){
 
-
 	int i;
-	
+
 	int found=0;
 	int mpi_found=0;
@@ -33,6 +32,6 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&mpi_found,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&mpi_found,1,MPI_INT,0,IssmComm::GetComm());                
 	found=mpi_found;
 	#endif
@@ -46,9 +45,8 @@
 	int num_unstable_constraints=0;
 	int converged=0;
-	int potential;
 
 	RiftConstrain(&num_unstable_constraints,loads,configuration_type);
 	if(num_unstable_constraints==0)converged=1;
-	
+
 	if(RiftIsFrozen(loads,configuration_type)){
 		converged=1;
@@ -69,5 +67,5 @@
 
 	int			i;
-	
+
 	/* generic object pointer: */
 	Riftfront* riftfront=NULL;
@@ -77,5 +75,5 @@
 	int sum_num_unstable_constraints;
 	int num_unstable_constraints=0;	
-		
+
 	/*Enforce constraints: */
 	for (i=0;i<loads->Size();i++){
@@ -96,9 +94,9 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,IssmComm::GetComm());                
 	num_unstable_constraints=sum_num_unstable_constraints;
 	#endif
-	
+
 	/*Assign output pointers: */
 	*pnum_unstable_constraints=num_unstable_constraints;
@@ -110,5 +108,5 @@
 
 	int			i;
-	
+
 	/* generic object pointer: */
 	Load*      load=NULL;
@@ -121,5 +119,5 @@
 
 		if (RiftfrontEnum==loads->GetEnum(i)){
-			
+
 			load=(Load*)loads->GetObjectByOffset(i);
 			if(load->InAnalysis(configuration_type)){
@@ -133,9 +131,9 @@
 		}
 	}
-	
+
 	/*Is there just one found? that would mean we have frozen! : */
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_MAX,0,MPI_COMM_WORLD );
-	MPI_Bcast(&mpi_found,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&mpi_found,1,MPI_INT,0,IssmComm::GetComm());                
 	found=mpi_found;
 	#endif
@@ -148,5 +146,5 @@
 
 	int			i;
-	
+
 	/* generic object pointer: */
 	Load*      load=NULL;
@@ -160,5 +158,5 @@
 			load=(Load*)loads->GetObjectByOffset(i);
 			if(load->InAnalysis(configuration_type)){
-				
+
 				riftfront=(Riftfront*)load;
 				riftfront->FreezeConstraints();
@@ -176,5 +174,5 @@
 
 	int i;
-	
+
 	Riftfront* riftfront=NULL;
 	int found=0;
@@ -196,6 +194,6 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&mpi_found,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&mpi_found,1,MPI_INT,0,IssmComm::GetComm());                
 	found=mpi_found;
 	#endif
@@ -207,7 +205,6 @@
 int RiftIsPreStable(Loads* loads){
 
-
 	int i;
-	
+
 	Riftfront* riftfront=NULL;
 	int found=0;
@@ -229,6 +226,6 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&mpi_found,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&found,&mpi_found,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&mpi_found,1,MPI_INT,0,IssmComm::GetComm());                
 	found=mpi_found;
 	#endif
@@ -246,7 +243,6 @@
 void RiftSetPreStable(Loads* loads){
 
-
 	int i;
-	
+
 	Riftfront* riftfront=NULL;
 	int found=0;
@@ -268,5 +264,5 @@
 
 	int			i;
-	
+
 	/* generic object pointer: */
 	Riftfront* riftfront=NULL;
@@ -275,5 +271,5 @@
 	int sum_num_unstable_constraints;
 	int num_unstable_constraints=0;	
-		
+
 	/*Enforce constraints: */
 	for (i=0;i<loads->Size();i++){
@@ -290,9 +286,9 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,IssmComm::GetComm());                
 	num_unstable_constraints=sum_num_unstable_constraints;
 	#endif
-	
+
 	/*Assign output pointers: */
 	*pnum_unstable_constraints=num_unstable_constraints;
@@ -304,5 +300,5 @@
 
 	int			i;
-	
+
 	/* generic object pointer: */
 	Riftfront* riftfront=NULL;
@@ -330,6 +326,6 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&max_penetration,&mpi_max_penetration,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
-	MPI_Bcast(&mpi_max_penetration,1,MPI_DOUBLE,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&max_penetration,&mpi_max_penetration,1,MPI_DOUBLE,MPI_MAX,0,IssmComm::GetComm() );
+	MPI_Bcast(&mpi_max_penetration,1,MPI_DOUBLE,0,IssmComm::GetComm());                
 	max_penetration=mpi_max_penetration;
 	#endif
@@ -346,5 +342,5 @@
 
 	int			i;
-	
+
 	/* generic object pointer: */
 	Riftfront* riftfront=NULL;
@@ -369,6 +365,6 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,IssmComm::GetComm());                
 	num_unstable_constraints=sum_num_unstable_constraints;
 	#endif
Index: issm/trunk/src/c/modules/ConstraintsStatex/ThermalConstraintsState.cpp
===================================================================
--- issm/trunk/src/c/modules/ConstraintsStatex/ThermalConstraintsState.cpp	(revision 13405)
+++ issm/trunk/src/c/modules/ConstraintsStatex/ThermalConstraintsState.cpp	(revision 13975)
@@ -37,6 +37,6 @@
 
 	#ifdef _HAVE_MPI_
-	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,MPI_COMM_WORLD );
-	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,MPI_COMM_WORLD);                
+	MPI_Reduce (&num_unstable_constraints,&sum_num_unstable_constraints,1,MPI_INT,MPI_SUM,0,IssmComm::GetComm() );
+	MPI_Bcast(&sum_num_unstable_constraints,1,MPI_INT,0,IssmComm::GetComm());                
 	num_unstable_constraints=sum_num_unstable_constraints;
 	#endif
